View a markdown version of this page

CreateImagePipeline - EC2 Image Builder
Services or capabilities described in Amazon Web Services documentation might vary by Region. To see the differences applicable to the China Regions, see Getting Started with Amazon Web Services in China (PDF).

CreateImagePipeline

Creates a new image pipeline. Use image pipelines to automate the creation and distribution of images.

Request Syntax

PUT /CreateImagePipeline HTTP/1.1 Content-type: application/json { "clientToken": "string", "containerRecipeArn": "string", "description": "string", "distributionConfigurationArn": "string", "dryRun": boolean, "enhancedImageMetadataEnabled": boolean, "executionRole": "string", "imageRecipeArn": "string", "imageScanningConfiguration": { "ecrConfiguration": { "containerTags": [ "string" ], "repositoryName": "string" }, "imageScanningEnabled": boolean }, "imageTags": { "string" : "string" }, "imageTestsConfiguration": { "imageTestsEnabled": boolean, "timeoutMinutes": number }, "infrastructureConfigurationArn": "string", "loggingConfiguration": { "imageLogGroupName": "string", "pipelineLogGroupName": "string" }, "name": "string", "schedule": { "autoDisablePolicy": { "failureCount": number }, "pipelineExecutionStartCondition": "string", "scheduleExpression": "string", "timezone": "string" }, "status": "string", "tags": { "string" : "string" }, "workflows": [ { "onFailure": "string", "parallelGroup": "string", "parameters": [ { "name": "string", "value": [ "string" ] } ], "workflowArn": "string" } ] }

URI Request Parameters

The request does not use any URI parameters.

Request Body

The request accepts the following data in JSON format.

clientToken

A unique, case-sensitive identifier you provide to ensure that the operation completes no more than one time. If this token matches a previous request, the service ignores the request, but does not return an error. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 64.

Required: Yes

containerRecipeArn

The Amazon Resource Name (ARN) of the container recipe that is used to configure images created by this container pipeline.

Type: String

Pattern: ^arn:aws[^:]*:imagebuilder:[^:]+:(?:[0-9]{12}|aws):container-recipe/[a-z0-9-_]+/(?:[0-9]+|x)\.(?:[0-9]+|x)\.(?:[0-9]+|x)$

Required: No

description

The description of the image pipeline.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 1024.

Required: No

distributionConfigurationArn

The Amazon Resource Name (ARN) of the distribution configuration that configures and distributes images created by this image pipeline.

Type: String

Pattern: ^arn:aws[^:]*:imagebuilder:[^:]+:(?:[0-9]{12}|aws):distribution-configuration/[a-z0-9-_]+$

Required: No

dryRun

Validates the required permissions and request parameters without making the request. If validation succeeds, the operation returns a DryRunOperationException error response.

Type: Boolean

Required: No

enhancedImageMetadataEnabled

Specifies whether to collect additional information about the image being created, including the operating system (OS) version and package list. Defaults to true.

Type: Boolean

Required: No

executionRole

The name or Amazon Resource Name (ARN) for the IAM role you create that grants Image Builder access to perform workflow actions.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 2048.

Pattern: ^(?:arn:aws(?:-[a-z]+)*:iam::[0-9]{12}:role/)?[a-zA-Z_0-9+=,.@\-_/]+$

Required: No

imageRecipeArn

The Amazon Resource Name (ARN) of the image recipe that configures images created by this image pipeline.

Type: String

Pattern: ^arn:aws[^:]*:imagebuilder:[^:]+:(?:[0-9]{12}|aws):image-recipe/[a-z0-9-_]+/(?:[0-9]+|x)\.(?:[0-9]+|x)\.(?:[0-9]+|x)$

Required: No

imageScanningConfiguration

Contains settings for vulnerability scans.

Type: ImageScanningConfiguration object

Required: No

imageTags

The tags to be applied to the images produced by this pipeline.

Type: String to string map

Map Entries: Maximum number of 50 items.

Key Length Constraints: Minimum length of 1. Maximum length of 128.

Key Pattern: ^(?!aws:)[a-zA-Z0-9\s_.:/=+\-@]*$

Value Length Constraints: Maximum length of 256.

Required: No

imageTestsConfiguration

The image test configuration of the image pipeline.

Type: ImageTestsConfiguration object

Required: No

infrastructureConfigurationArn

The Amazon Resource Name (ARN) of the infrastructure configuration that builds images created by this image pipeline.

Type: String

Pattern: ^arn:aws[^:]*:imagebuilder:[^:]+:(?:[0-9]{12}|aws):infrastructure-configuration/[a-z0-9-_]+$

Required: Yes

loggingConfiguration

Specifies the logging configuration for the image pipeline. Use this to define custom CloudWatch Logs log groups for your pipeline execution logs and image build logs. The service manages log groups with names starting with /aws/imagebuilder/ using the service-linked role. For custom log group names outside of this prefix, you must also provide an executionRole.

Type: PipelineLoggingConfiguration object

Required: No

name

The name of the image pipeline.

Type: String

Pattern: ^[-_A-Za-z-0-9][-_A-Za-z0-9 ]{1,126}[-_A-Za-z-0-9]$

Required: Yes

schedule

The schedule of the image pipeline.

Type: Schedule object

Required: No

status

The status of the image pipeline.

Type: String

Valid Values: DISABLED | ENABLED

Required: No

tags

The tags of the image pipeline.

Type: String to string map

Map Entries: Maximum number of 50 items.

Key Length Constraints: Minimum length of 1. Maximum length of 128.

Key Pattern: ^(?!aws:)[a-zA-Z0-9\s_.:/=+\-@]*$

Value Length Constraints: Maximum length of 256.

Required: No

workflows

Contains an array of workflow configuration objects.

Type: Array of WorkflowConfiguration objects

Required: No

Response Syntax

HTTP/1.1 200 Content-type: application/json { "clientToken": "string", "imagePipelineArn": "string", "requestId": "string" }

Response Elements

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

clientToken

The client token that uniquely identifies the request.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 64.

imagePipelineArn

The Amazon Resource Name (ARN) of the image pipeline that was created by this request.

Type: String

Pattern: ^arn:aws[^:]*:imagebuilder:[^:]+:(?:[0-9]{12}|aws):image-pipeline/[a-z0-9-_]+$

requestId

The request ID that uniquely identifies this request.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 1024.

Errors

For information about the errors that are common to all actions, see Common Error Types.

CallRateLimitExceededException

You have exceeded the permitted request rate for the specific operation.

HTTP Status Code: 429

ClientException

These errors are usually caused by a client action, such as using an action or resource on behalf of a user that doesn't have permissions to use the action or resource, or specifying an invalid resource identifier.

HTTP Status Code: 400

DryRunOperationException

The dry run operation of the resource was successful, and no resources or mutations were actually performed due to the dry run flag in the request.

HTTP Status Code: 412

ForbiddenException

You are not authorized to perform the requested operation.

HTTP Status Code: 403

IdempotentParameterMismatchException

You have specified a client token for an operation using parameter values that differ from a previous request that used the same client token.

HTTP Status Code: 400

InvalidRequestException

You have requested an action that that the service doesn't support.

HTTP Status Code: 400

ResourceAlreadyExistsException

The resource that you are trying to create already exists.

HTTP Status Code: 400

ResourceInUseException

The resource that you are trying to operate on is currently in use. Review the message details and retry later.

HTTP Status Code: 400

ServiceException

This exception is thrown when the service encounters an unrecoverable exception.

HTTP Status Code: 500

ServiceQuotaExceededException

You have exceeded the number of permitted resources or operations for this service. For service quotas, see EC2 Image Builder endpoints and quotas.

HTTP Status Code: 402

ServiceUnavailableException

The service is unable to process your request at this time.

HTTP Status Code: 503

See Also

For more information about using this API in one of the language-specific Amazon SDKs, see the following: